import { Page } from '../../utils/scan';
import { API_USE_COUPON } from '../../const/apiurl'
var api = require("../../utils/api.js");

import { ACTION_GO_SCAN } from '../../const/actioncmd'

Page({
  data: {
    scanDialogDisplay: 0
  },

  onLoad() {

  },

  onShow(){
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);
        if(res.action == ACTION_GO_SCAN){
          my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_GO_SCAN,
              data: null
            },
            success: (res) => {
              console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
              //跳转到扫码页面
              my.reLaunch({
                url: "/pages/scan/scan",
              });
            },
            fail: (res) => {
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });
        } else {
          //未知指令
        }
      }
    });
  },

  onHide() {
    // 页面隐藏
    //关闭后屏监听
    my.ix.offBuddyMessage();
  },


  onReady() {
    if (my.canIUse('hideBackHome')) {
      my.hideBackHome();
    }
  },

  homeTap() {
   
  },

  //显示弹窗，>1为显示，2loading 3 result success 4 result failed

  showDialog() {
    this.setData({
      scanDialogDisplay: 1
    }
    )
    console.log(this.data.scanDialogDisplay);

  },

  //外接扫码枪事件
  onKeyPress(r) {
    console.log(" onKeyPress==>" + r);
    //核销券
    if (this.data.scanDialogDisplay == 1) {
      this.verifyCoupon(r)
      return;
    }
    my.reLaunch({
      url: "/pages/scan/scan?barcode=" + r,
    });
  },

  //核销券
  verifyCoupon(code) {
    this.setData({scanDialogDisplay:2})
    var couponRequest = api.createCommonRequest();
    couponRequest.couponCode = code;
    console.log("核销券的请求 ==>" + JSON.stringify(couponRequest));
    my.request({
      url: getApp().globalData.BASE_URL + API_USE_COUPON,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: couponRequest,
      success: (res) => {
        if (res.data.success != true) {
          this.setData({scanDialogDisplay:4})
          console.log("核销券失败 ==>" + res.data.message);
        } else {
          this.setData({scanDialogDisplay:3})
          console.log("核销券成功 ==>" + JSON.stringify(res));
        }
      },
      fail: (res) => {
        this.setData({scanDialogDisplay:4})
        console.log("核销券失败 ==>" + JSON.stringify(res));
        my.showToast({
          type: 'exception',
          content: api.decodeErrorMessage(res.error),
          duration: 2000
        });
      }
    });
  },




});
